Improve docs.
[wizbackup.git] / wizbackup
index 034651a997fd3747d17f4c4c257ed3bda82796df..746cfba7022435e3c1924188fa2c09ed329c0ce0 100755 (executable)
--- a/wizbackup
+++ b/wizbackup
@@ -1,66 +1,85 @@
 #!/bin/bash
 #
-# wizbackup 2.0 - Simple rsync backup
+# WizBackup 3.0 - Simple rsync backup with snapshots
 # Based on incremental-backup 0.1 by Matteo Mattei
 #
 # Copyright 2006 Matteo Mattei <matteo.mattei@gmail.com>
-# Copyright 2007, 2008, 2009, 2010, 2011 Bernie Innocenti <bernie@codewiz.org>
+# Copyright 2007, 2008, 2009, 2010, 2011, 2012, 2015 Bernie Innocenti <bernie@codewiz.org>
+#
+#  This program is free software: you can redistribute it and/or modify
+#  it under the terms of the GNU General Public License as published by
+#  the Free Software Foundation, either version 3 of the License,
+#  or (at your option) any later version.
+#
+#  This program is distributed in the hope that it will be useful,
+#  but WITHOUT ANY WARRANTY; without even the implied warranty of
+#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#  GNU General Public License for more details.
+#
+#  You should have received a copy of the GNU General Public License
+#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License,
-# or (at your option) any later version.
-
 
 if [ $# -lt 2 ]; then
        echo "Usage: $0 SOURCE DEST [RSYNC_OPTS]"
        exit 1
 fi
 
-# Fail on any error; Treat undefined variables as errors
-set -e -u
+# Treat undefined variables as errors
+set -u
 
 #####################################################################
 # CONFIGURATION
 #####################################################################
 
-# Source path
+# Source rsync URL
 SRC=$1; shift
 
-# DESTINATION DIRECTORY (must exists)
+# Destination directory (will be created if it doesn't exist)
 DEST=$1; shift
 
+CONFIG_FILE="/etc/wizbackup/wizbackup.conf"
+
 # NOTE: --timeout needs to be large enough: if a large dir tree don't change a lot of time can pass without I/O
 # NOTE: --inplace will clobber linked files in older snapshots. DON'T USE IT!
-RSYNC_OPTIONS="-HAXa --stats --timeout 1800 --numeric-ids --delete --delete-excluded --ignore-errors $@"
-# NUMBER OF SAVED ARCHIVES
-N_SNAPSHOT=45
-RESULT=500
+RSYNC_OPTS="-HAXa --stats --timeout 1800 --numeric-ids --delete --delete-excluded --ignore-errors $@"
+
+# Number of months to keep
+MONTHS=3
 
-DATE=`date +"%Y%m%d"`
+# Abort backup if the destination volume has less than these GBs free
+MIN_FREE_GB=10
+
+RESULT=500
+DATE="$(date +"%Y%m%d")"
+if [ $(date +"%d") -eq 1 ]; then
+       DATE="${DATE}-monthly"
+elif [ $(date +"%w") -eq 0 ]; then
+       DATE="${DATE}-weekly"
+fi
 DEST="`echo $DEST | sed -e 's/\/$//'`"
 
+if [ -f "$CONFIG_FILE" ]; then
+       source "$CONFIG_FILE"
+fi
 
 # Use "backup" ssh key with ssh protocol, or password file for rsync protocol
 if [ "${SRC%:*}" == "rsync" ]; then
-       RSYNC_PWD="--password-file=/etc/wizbackup.pwd --contimeout 10"
+       RSYNC_OPTS="$RSYNC_OPTS --password-file=/etc/wizbackup/rsync_password --contimeout 10"
 else
-       export RSYNC_RSH="ssh -i /root/.ssh/id_backup -c arcfour -x -o VerifyHostKeyDNS=yes"
-       RSYNC_PWD=""
+       export RSYNC_RSH="ssh -i /etc/wizbackup/ssh_id -x -o VerifyHostKeyDNS=yes -o StrictHostKeyChecking=no"
 fi
 
 # Error tolerant grep
-tgrep()
-{
+tgrep() {
        grep "$@"
        return 0
 }
 
-do_backup()
-{
+do_backup() {
        set -o pipefail
-       echo "$(date): Starting rsync: rsync $RSYNC_PWD $RSYNC_OPTIONS $SRC $DEST/$DATE/"
-       rsync $RSYNC_PWD $RSYNC_OPTIONS "$SRC" "$DEST/tmp/" 2>&1 | tgrep -v -E 'vanished|some files'
+       echo "$(date): rsync $RSYNC_OPTS $SRC $DEST/tmp/"
+       rsync $RSYNC_OPTS "$SRC" "$DEST/tmp/" 2>&1 | tgrep -v -E 'vanished|some files'
        RESULT=$?
        case "$RESULT" in
        0|24)
@@ -80,9 +99,7 @@ do_backup()
        set +o pipefail
 }
 
-
-do_init()
-{
+do_init() {
        # Safety net (4 slashes just in case)
        case "$DEST" in
                /|//|///|////) exit 666 ;;
@@ -96,36 +113,52 @@ do_init()
        cd "$DEST" || exit 668
 }
 
-do_prune()
-{
-       local old="`ls | grep -v tmp | head -n -$N_SNAPSHOT`"
-       if [ ! -z "$old" ]; then
+do_prune() {
+       local num_snapshots="$1"
+       local suffix="$2"
+       local oldest="$(ls 2>/dev/null -d [0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]$suffix | head -n -$num_snapshots)"
+       for old in $oldest; do
                echo "$(date): Removing oldest snapshot(s): $old..."
                rm -rf "$old" || exit 669
-       fi
+       done
 }
 
-do_link()
-{
-       local newest=`ls | grep  -v tmp | tail -n 1`
-       if [ -z "$newest" ]; then
+do_link() {
+       local newest=`ls -d [0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]* | tail -n 1`
+       if [ -d "$DEST/tmp" ]; then
+               echo "$(date): Continuing with pre-existing snapshot $DEST/tmp"
+       elif [ -z "$newest" ]; then
                echo "$(date): No previous snapshot found, performing a full backup!"
-       elif [ -d "$DEST/tmp" ]; then
-               echo "$(date): Continuing with preexisting snapshot $DEST/tmp"
        else
                echo "$(date): Linking snapshot $DEST/$newest to $DEST/tmp"
                # TODO: Creating the hardlinks takes a lot of time.
                # Perhaps we could save time by recycling the oldest snapshot
-               cp -lR "$DEST/$newest" "$DEST/tmp" || exit 670
+               cp -la "$DEST/$newest" "$DEST/tmp"
+               RESULT=$?
+               if [ $RESULT -ne 0 ]; then
+                       echo "$(date): Failed to setup tmp snapshot: $RESULT. Cleaning up."
+                       rm -rf "$DEST/tmp"
+                       exit $RESULT
+               fi
        fi
 }
 
-do_test()
-{
+do_test() {
+       # TODO: test for free space and free inodes in the $DEST filesystem
+       block_size=`stat --file-system --format "%S" "$DEST"`
+       free_blocks=`stat --file-system --format "%f" "$DEST"`
+       free_inodes=`stat --file-system --format "%d" "$DEST"`
+       free_gb=$((block_size * free_blocks / 1024 / 1024 / 1024))
+
+       if [ "$free_gb" -lt "$MIN_FREE_GB" ]; then
+               echo "$(date): Aborting due to insufficient free space ${free_gb}GB."
+               exit 670
+       fi
+
        # Avoid clobbering the latest snapshot if the remote host does
        # not allow us to connect
        # --contimeout: sometimes hangs on connection...
-       rsync $RSYNC_PWD $RSYNC_OPTIONS --dry-run --no-recursive "$SRC" >/dev/null
+       rsync $RSYNC_OPTS --dry-run --no-recursive "$SRC" >/dev/null
        RESULT=$?
        if [ $RESULT -ne 0 ]; then
                echo "$(date): rsync test failed: $RESULT.  Aborting."
@@ -133,16 +166,18 @@ do_test()
        fi
 }
 
-######################
-# MAIN
-######################
+######################################
+# Main
+######################################
 
 # make sure to be root
 if (( `id -u` != 0 )); then { echo "Sorry, must be root.  Exiting..."; exit; } fi
 
-echo "$(date): START backup: $SRC -> $DEST"
+echo "$(date): BEGIN backup: $0 $SRC $DEST $@"
 do_init
-do_prune
+do_prune 6 ""
+do_prune 4 "-weekly"
+do_prune $MONTHS "-monthly"
 do_test
 do_link
 do_backup